# -*- coding: utf-8 -*-
"""final.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1sVpY1aSPsoNCbeShhUemBGqFCSWDzlxM

# Introduction to Pandas Library

## 1. Introduction to Pandas

Pandas is an open source Python package that is most widely used for data science/data analysis and machine learning tasks. It is built on top of another package named Numpy, which provides support for multi-dimensional arrays

### 1.1 Pandas Data structure

The heart of pandas is just the two primary data structures on which all transactions, which are generally
made during the analysis of data, are centralized

#### 1.1.1 Series
The Series is the object of the pandas library designed to represent one-dimensional data structures,
similarly to an array but with some additional features.

Its internal structure is simple and is composed of two arrays associated with each other. The main array has the purpose to hold the data (data of any NumPy type) to which each element is associated with a label, contained within the other array, called the Index.
"""

# defining series with python list
import pandas as pd
series = pd.Series([2,4,6,8])

series

"""#### 1.1.2. DataFrame

The DataFrame is a tabular data structure very similar to the Spreadsheet (the most familiar are Excel
spreadsheets). This data structure is designed to extend the case of the Series to multiple dimensions. In fact,
the DataFrame consists of an ordered collection of columns, each of which can contain a
value of different type (numeric, string, Boolean, etc.).

Unlike Series, which had an Index array containing labels associated with each element, in the case
of the data frame, there are two index arrays. The first, associated with the lines, has very similar functions
to the index array in Series. In fact, each label is associated with all the values in the row. The second array
instead contains a series of labels, each associated with a particular column.

## 2. Syntax to create DataFrame
pandas.DataFrame(data=None, index=None, columns=None, dtype=None)
"""

# defining Dataframe with python dictionary
data = {'name':['sonam','pema','karma'],
       'age' : [20,30,40],
       'marks':[60,70,80]}

df = pd.DataFrame(data)
df

"""##### 2.2 Reading file using pandas"""

#import file using
#pd.read_csv("filename")
#pd.read_excel("filename")

data = pd.read_excel("yelp.xlsx")
data

"""## 3. View Data"""

#use index attributes

data.index

#use columns attributes to check column names
data.columns

#use dtypes attributes to check data types of each features
data.dtypes

#use shape attribute to get rows and columns of your dataframe
data.shape

#use info attributes to check summary of data
df.info(verbose=True)

#use values attributes to get values in numpy array
data.values

#use haead() and tail() method inspect selected data

data.head()

data.tail()

data.head(10)

#use describe() method to generate desciptive statistics
data.describe()

"""## 4.  Adding new columns"""

data['newcolumn'] = 45

data.head()

import numpy as np
data['newcolumn2'] = np.arange(0,data.shape[0])

data.head()

newdf = data[['name','stars','newcolumn']]

newdf.head()

"""## 5. Selection

pandas provides optimized data access methods, .at, .iat, .loc,.iloc and .ix for selecting subsets of a dataset.  Practise these methods by completing the lab questions below.

## A. Sebset Columns

### *Task1: Select column by column name*

Select specific columns by using their columns name (loc)

Load the data from the "yelp.xlsx" file into a Pandas DataFrame object mydf . 

Select all the rows in the "category_0" column and store them in a dataframe named df_category. Print out the values of df_category. Your output should look similar to that below
![image.png](attachment:image.png)


Select all the rows in the last three columns and store them in a dataframe named df_last_three.  Print out the values of df_last_three

Your output should look similar to that below
![image-2.png](attachment:image-2.png)
"""

#write your code here
import pandas as pd
df = pd.read_excel('yelp.xlsx')
df.head()

#write your code here
df.head()
df_category = df.loc[:, 'category_0']
print(df_category)

last_three = df.columns[-3:]
df_last_three = df.loc[:,last_three]
print(df_last_three)

data.loc[:, last_three]

#for slicing ':', is used
#To print specified number of column like if it is 2, we write ':2'
df_category = data.loc[:, 'take_out']
df_category

#to select multiple columns
df_category2 = data.loc[:,['name','take_out']]
df_category2

#to print last three columns
three = data.columns[-3:]

"""### *Task 2: Select column by index*

Pick specific columns using their column index (iloc)

Load the data from the yelp.xlsx file into a Pandas DataFrame object mydf . Set the index as the first column of the Excel file 

- Select the first, second,and third columns of data and store them in a dataframe named df_index123. Print out the values of df_index123

- Select the last 4 columns and store them in a dataframe named df_last4cols. Print out the values of df_last4cols

Your output should look similar to that below
![image.png](attachment:image.png)

![image-2.png](attachment:image-2.png)
"""

#selecting first three columns
df_index123 = data.iloc[:,:3]
df_index123

#selecting the last four columns
df_last4cols = data.iloc[:5,-4:]
df_last4cols

"""### *Task 3: Create derived columns by boolean logic*

Pick specific columns  with  values < 10

use same dataframe 

- Find out how many rows of the data in the review_count column have values less then 10 and how many rows by of the data have values more than or equal to 20 by creating a derived column using boolean indexing on this column and using the count() or sum() method.

Your output should be : 279 and 315 respectively

"""

print((df.review_count < 10).sum())

print((df.review_count >= 10).sum())

"""### *Task 4: Select columns by regular expression*

Pick specific columns that start with characters "category" (filter)


Select the columns that start with “category” and store them in a dataframe named df_category
Print out the values of df_category

Your output should look similar to that below.
![image.png](attachment:image.png)

"""

#using .head() at the end, it will print first 5 values
df.filter(regex = "cate",axis = 1).head()
#df.filter(like = 'cate')

"""## B. Sebset Rows

### *Task 1: Select rows(s) by index label*
Use loc method to select yelp data from rows containing 3rd only

Use df.loc to select only 3rd rows and display the data.

![image.png](attachment:image.png)
"""

# df_rows = data.iloc[:3, :]
# df_rows
df.loc[[3]]

"""### *Task 2: Use iloc method to select data from last 12 rows of dataset*

![image.png](attachment:image.png)
"""

df.iloc[-12:]

"""### *Task 3: Select columns by regular expression*

Pick specific rows with row number which contains 0 (filter)

![image.png](attachment:image.png)
"""

df.filter(regex='0', axis=0).head()

"""## 6. Reshaping Data

### A. Drop columns and rows from data frame

### *Task 1: Drop columns and rows from a DataFrame*

Load the data from the yelp.excel file into a Pandas DataFrame object df .

Using the drop() method, perform the following operations in order and print out the shape of the transofrmed DataFrame object at each stage.  

Your output should include all the operations given below.

**Operation 1**
- Remove the following columns
- **name** column
- **cetegory_1** column
- **review_count** column
![image.png](attachment:image.png)



**Operation 2**
Remove records that has category_1 as 
- "Chinese".
- "Casinos"
- "Pizza"

![image-2.png](attachment:image-2.png)
"""

import pandas as pd
df = pd.read_excel('yelp.xlsx')
df
#df.drop(['name', 'category_0', 'review_count'], axis=1)

#removing records that has category_1 as 
# "Chinese".
# "Casinos"
# "Pizza"
remove_index = df[(df['category_1'] == 'Chinese') | (df['category_1'] == 'Casinos') | (df['category_1'] == 'Pizza')].index

df.drop(remove_index)

"""### B. Append columns/rows to a DataFrame

### *Task 1: Concatenate the data of two DataFrames by rows*

Concat data from two dataframe.

Load the data from the pa-performing-arts-courses.csv and pa-sports-courses.csv files into the Pandas DataFrame object df_arts and df_sports respectively

Use multiple_of_5df and multiple_of_10df to perform following operations.

- Print out the shape of  mulitple_of_5df as well as the data of its first 2 rows and last 2 rows
- Print out the shape of multiple_of_10df as well as the data of its first 2 rows and last 2 rows

Use the concat method to combine the two DataFrame objects to a new DataFrame object named df_all

Print out the shape of  df_all as well as the data of its first 3 rows and last 3 rows

Your output should look similar to that below.
"""

#use these dataframe
multiple_of_5df = df.filter(regex='5$', axis=0)
multiple_of_10df = df.filter(regex='0$', axis=0)

multiple_of_10df.shape
multiple_of_5df.shape

mydf = pd.concat([multiple_of_5df, multiple_of_10df])
mydf

"""### *Task 2: Concatenate the data of two DataFrames by columns*"""

df1 = pd.DataFrame({
       'President':['Audrey','Kinga']},index=["GCIT","Sherubtse"])
df2 = pd.DataFrame({
                   'Location':['Mongar','Kanglung']},index=["GCIT","Sherubtse"])

#write your solution here using df1 and df2 declared above
df2

df_all = pd.concat([df1,df2], axis=1)
df_all

"""## C: Spread rows into columns (pivot)

## *Task 1: Transpose rows into columns*

Load the data from the yelp.xlsx file into a Pandas DataFrame object mydf.

use given data_df to apply pivot to transpose rows into columns

Your output should look similar to that below
![image.png](attachment:image.png)
"""

data_df = pd.DataFrame({'name':['sonam','Tshering','Pema',"Leki",'Ugyen'],
                       'age':[20,30,21,23,35],
                       'marks':[45,55,60,45,55]})

data_df.pivot(index = 'name', columns = 'marks', values='age')

"""## D. Sort a DataFrame

### *Task 1: Sort DataFrame by column values*

Sort data by column 

Load the data from the yelp.xlsx file into a Pandas DataFrame object mydf.

Print out the first 10 rows of mydf
Sort the data by the column **review_count** in descending order
Print out the first 10 rows of the sorted dataframe
Print out the last 10 rows of the sorted dataframe

Your ouput of first few rows will look similar to that below
![image.png](attachment:image.png)
"""

df.sort_values(by=['review_count'], ascending=False).head(10)

"""### *Task 2: Sort DataFrame by index  values*

Use "yelp.xlsx" data 

Set the index columns to be “review_count” and “category_1”
Print out the first 10 rows of mydf

Use the sort_index method on the **review_count** index to sort the data in descending order,
Use the sort_index method on the **review_count** index to sort the data in ascending order,


Print out the first 10 rows of the sorted dataframe
Print out the last 10 rows of the sorted dataframe


"""

mydf = df.set_index(['review_count', 'category_1']).head(10)

mydf.sort_index()

"""## E. Rename the columns of a DataFrame

### *Task 1: Rename the columns of  a DataFrame*

Load the data from the yelp.xlsx file into a Pandas DataFrame object mydf . 

Print out the first 5 rows of the dataset
Next, use the pandas rename method to rename the column names to "resturant_name", "type_1", "type_2" "review","delivery" "rating" respectively.
Print out renamed dataset
"""

df.head()

"""## F. Check duplicate data"""

renamed_df = df.rename(columns={'name':'restuarant_name','category_0':'type_1', 'category_1':'type_2','take_out':'delivery','review_count':'review','stars':'rating'})
renamed_df

"""### *Task 1: Check duplicates in a dataframe*

1. use duplicated() to check duplicates records in yelp data sets.
2. check duplicated value in **name** column
"""

df.duplicated()

"""### *Task 2: remove duplicates*

1. use drop_duplicates() method to remove duplicates rows

2. use drop_duplciates() to remove records with duplicate name.
"""

df.drop_duplicates()

df.drop_duplicates(subset=['name'])

"""# THANK YOU"""

